=begin
Agrid Quotes API



OpenAPI spec version: 1.0

Generated by: https://github.com/swagger-api/swagger-codegen.git


=end

require 'date'
require_relative 'concerns/swagger_model'

module AgridClient
  class Quote
    include SwaggerModel

    # Unique Id
    attr_accessor :id

    # Quote title
    attr_accessor :title

    # Quote price
    attr_accessor :price

    # Array of images to ilustrate the quote
    attr_accessor :images

    # Company that offers this quote
    attr_accessor :company

    # Service that contain this quote
    attr_accessor :service

    # Items included on this quote
    attr_accessor :categories

    # Goodsfor used to filter quotes
    attr_accessor :filters

    attr_accessor :active_sale

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'title' => :'title',
        :'price' => :'price',
        :'images' => :'images',
        :'company' => :'company',
        :'service' => :'service',
        :'categories' => :'categories',
        :'filters' => :'filters',
        :'active_sale' => :'active_sale'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'title' => :'String',
        :'price' => :'Float',
        :'images' => :'Array<String>',
        :'company' => :'Company',
        :'service' => :'Service',
        :'categories' => :'Array<Category>',
        :'filters' => :'Array<Filter>',
        :'active_sale' => :'Sale'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes[:'id']
        self.id = attributes[:'id']
      end
      if attributes[:'title']
        self.title = attributes[:'title']
      end
      if attributes[:'price']
        self.price = attributes[:'price']
      end
      if attributes[:'images']
        if (value = attributes[:'images']).is_a?(Array)
          self.images = value
        end
      end
      if attributes[:'company']
        self.company = attributes[:'company']
      end
      if attributes[:'service']
        self.service = attributes[:'service']
      end
      if attributes[:'categories']
        if (value = attributes[:'categories']).is_a?(Array)
          self.categories = value
        end
      end
      if attributes[:'filters']
        if (value = attributes[:'filters']).is_a?(Array)
          self.filters = value
        end
      end
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id
    end
  end
end
